"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformSfcRefSugar = void 0;
const ref_transform_1 = require("@vue/ref-transform");
const magic_string_1 = require("magic-string");
const babel_1 = require("./babel");
function transformSfcRefSugar(sfc, options) {
    const importedHelpers = new Set();
    for (const script of [sfc.script, sfc.scriptSetup]) {
        if ((0, ref_transform_1.shouldTransform)(script.content)) {
            const s = new magic_string_1.default(script.content);
            const { importedHelpers: imports } = (0, ref_transform_1.transformAST)(script.ast, s);
            Array.from(imports).forEach(helper => importedHelpers.add(helper));
            script.content = s.toString();
            script.ast = (0, babel_1.parse)(script.content, sfc.parserOptions).program;
        }
    }
    if (importedHelpers.size) {
        sfc.extraDeclarations = [
            babel_1.t.importDeclaration(Array.from(importedHelpers).map(i => babel_1.t.importSpecifier(babel_1.t.identifier(`_${i}`), babel_1.t.identifier(i))), babel_1.t.stringLiteral(options.importHelpersFrom)),
        ];
    }
}
exports.transformSfcRefSugar = transformSfcRefSugar;
