"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unplugin = void 0;
const tslib_1 = require("tslib");
const unplugin_1 = require("unplugin");
const pluginutils_1 = require("@rollup/pluginutils");
const core_1 = require("./core");
(0, tslib_1.__exportStar)(require("./core"), exports);
exports.unplugin = (0, unplugin_1.createUnplugin)((options = {}) => {
    const filter = (0, pluginutils_1.createFilter)(options.include || (options.refTransform ? [/\.vue$/, /\.vue\?vue/, /\.[jt]sx?$/] : [/\.vue$/, /\.vue\?vue/]), options.exclude || [/node_modules/, /\.git/, /\.nuxt/]);
    return {
        name: 'unplugin-vue2-script-setup',
        enforce: 'pre',
        transformInclude(id) {
            return filter(id);
        },
        transform(code, id) {
            try {
                return (0, core_1.transform)(code, id, options);
            }
            catch (e) {
                this.error(e);
            }
        },
    };
});
exports.default = exports.unplugin;
